#ifndef STU_H
#define STU_H
#include <bits/stdc++.h>
using namespace std;

class stree {
private:
   static const int inf = 1e9;
   static const int maxn = 1e4;
   char s[ maxn ];
   int node, pos;
   int sz, n;
   int make_node( int, int );
   void go_edge( void );
   void add_letter( char c );
   void image_node( pair< const char, int >& n ) {
      cout << "<" << n.second << ">" << n.first;
      int i = n.second;
      cout << "[" << spos[ i ] << ":" << len[ i ] << "]:" 
           << string( s ).substr( spos[ i ], len[ i ] ) << endl;    
   }
   void put_node( pair< const char, int >& n, int levl ) {
      for( int i = 0; i < levl; i++ ) cout << '\t'; 
      image_node( n );
      int i = n.second;
      if( !to[ i ].empty() )
         show_tree( i, levl + 1 );
   }
public:
   int len[ maxn ], spos[ maxn ], link[ maxn ];
   map< char, int > to[ maxn ];
   inline int nodes( void ) { return sz; }
   stree( string& text ) {                                  // суффиксное дерево
      sz = 1; n = node = pos = 0; len[ 0 ] = inf;
      for( unsigned i = 0; i < text.size(); i++ ) 
         add_letter( text[ i ] );
      for( int i = 0; i < sz; i++ ) 
         len[ i ] = min( (int)strlen( s ) - spos[ i ], len[ i ] );
   }
//---------------------------- диагностика дерева ----------------------------------------
   void show_internal( void ) {
      cout << "{pos,len,link}: ";
      for( int i = 1; i < sz; i++ ) 
         cout << "{" << i << ":" << spos[ i ] << ","  << len[ i ] << "," << link[ i ] << "} ";
      cout << endl;
      vector<int> nil; 
      for( int i = 0; i < sz; i++ ) {
         if( !to[ i ].size() ) {
            nil.push_back( i );
            continue;
         }
         cout << i << ":\tmap size " << to[ i ].size() << " : ";
         for( auto &x : to[ i ] )
            cout << "[" << (char)x.first << "," << x.second << "] ";
         cout << endl;
      }
      cout << "empty maps: ";
      for( int x : nil ) cout << x << " ";
      cout << endl;
   }
   void show_tree( int layer = 0, int levl = 0 ) {
      for( auto &n : to[ layer ] )
         put_node( n, levl );
   } 
//------------------------ поиск образца по дереву ---------------------------------------
private:
   int len_root;                                            // путевая длина      
   int find_root( const string& pattern, int levl = 0 ) {
      if( 0 == levl ) len_root = 0;                         // поиск от корня
      map< const char, int >::iterator it;
      for( it = to[ levl ].begin(); it != to[ levl ].end(); it++ ) 
         if( it->first == pattern[ 0 ] ) break;
      if( it == to[ levl ].end() )                          // нет 1-го символа
         return -1;
      int n = it->second;                                   // длина найденой дуги 
      if( !to[ n ].empty() )                                // увеличить путевую длину     
         len_root += len[ n ]; 
      for( int m = 1; m < min( (int)pattern.size(), len[ n ] ); m++ ) 
         if( pattern[ m ] != *( s + spos[ n ] + m ) )       // не совпадает с патерном
            return -1;
      if( (int)pattern.size() <= len[ n ] )                 // найдена последняя дуга
         return n;
      return find_root( pattern.substr( len[ n ] ), n );    // спускаемся ниже в ветвь
   }
   void add_leave( int node, int shift, vector<int>& vps  ) {
      if( to[ node ].empty() ) {                            // терминальная вершина (лист)
         vps.push_back( spos[ node ] - shift );
         return;
      }
      for( auto &x: to[ node ] ) {
         int n = x.second;
         if( to[ n ].empty() )                              // терминальная вершина (лист)
            add_leave( n, shift, vps );
         else                                               // внутренний узел
            add_leave( n, shift + len[ n ], vps );
      }
   }
public:
   vector<int> find_pos( const string& pattern ) {
      vector<int> ret = {};
      int r = find_root( pattern );
      if( r > 0 ) 
         add_leave( r, len_root, ret );                  // пересчитать листья
      return ret;
   }   
};

#endif
