#include "stw.h"

//--------- упрощённый алгоритм Вейнера построения суффиксного дерева -------------
//----------------- построение дерева - приватные методы --------------------------

void stree::attach( int child, int parent, char c, int child_len ) {
   to[ parent ][ c ] = child;
   len[ child ] = child_len;
   par[ child ] = parent;
}

void stree::extend( int i ) {
   int v, vlen = s.size() - i, old = sz - 1, pstk = 0; 
   for( v = old; !link[ v ].count( s[ i ] ); v = par[ v ] ) {
      vlen -= len[ v ];
      path[ pstk++ ] = v;
   }
   int w = link[ v ][ s[ i ] ]; 
   if( to[ w ].count( s[ i + vlen ] ) ) {
      int u = to[ w ][ s[ i + vlen ] ]; 
      for( pos[ sz ] = pos[ u ] - len[ u ]; s[ pos[ sz ] ] == s[ i + vlen ]; pos[ sz ] += len[ v ] ) {
         v = path[--pstk];
         vlen += len[v];
      }
      attach( sz, w, s[ pos[ u ] - len[ u ] ], len[ u ] - ( pos[ u ] - pos[ sz ] ) );
      attach( u, sz, s[ pos[ sz ] ], pos[ u ] - pos[ sz ] );
      w = link[ v ][ s[ i ] ] = sz++;
   }
   link[ old ][ s[ i ] ] = sz;
   attach( sz, w, s[ i + vlen ], s.size() - ( i + vlen ) );
   pos[ sz++ ] = s.size();
}

