#ifndef STW_H
#define STW_H
#include <bits/stdc++.h>
using namespace std;

class stree {
private:
   void attach( int child, int parent, char c, int child_len );
   void extend( int i );
   string s;
   static const int MAXLEN = 10000; 
   int path[ MAXLEN ];
   map< char,int > to[ MAXLEN ], link[ MAXLEN ];
   int sz;
public:
   int pos[ MAXLEN ], len[ MAXLEN ], par[ MAXLEN ];
   inline int nodes( void ) { return sz - 1; }
   stree( string& text ) : s( text ) {                      // суффиксное дерево
      for( auto &m : to ) m.clear();
      for( auto &m : link ) m.clear();
      sz = 2;
      len[ 1 ] = 1; pos[ 1 ] = 0; par[ 1 ] = 0;
      for( int c = 0; c < 256; c++ )
         link[ 0 ][ c ] = 1; 
      for( int i = s.size() - 1; i >= 0; i-- )
	 extend( i );
   }
//---------------------------- диагностика дерева ----------------------------------------
   void show_internal( void ) {
      cout << "{pos,len,par}: ";
      for( int i = 2; i <= sz; i++ ) 
         cout << "{" << i << ":" << pos[ i ] << "," << len[ i ] << "," << par[ i ] << "} ";
      cout << endl;
      vector<int> nil;
      for( int i = 1; i < sz; i++ ) {
         if( !to[ i ].size() ) {
            nil.push_back( i );
            continue;
         }
         cout << i << ": map size " << to[ i ].size() << " : ";
         for( auto &x : to[ i ] )
            cout << "[" << (char)x.first << "," << x.second << "] ";
         cout << endl;
      }
      cout << "empty maps: ";
      for( int x : nil ) cout << x << " ";
      cout << endl;
   }
   void image_node( pair< const char, int >& n ) {
      int i = n.second;
      cout << "<" << n.second << ">" << n.first
           << "[" << pos[ i ] - len[ i ] << ":" << len[ i ] << "]:" 
           << string( s ).substr( pos[ i ] - len[ i ], len[ i ] ) << endl;
   }
   void put_node( pair< const char, int >& n, int levl ) {
      for( int i = 0; i < levl; i++ ) cout << '\t';
      image_node( n );
      int i = n.second;
      if( !to[ i ].empty() )
         show_tree( i, levl + 1 );
   }
   void show_tree( int layer = 1, int levl = 0 ) {
      for( auto &n : to[ layer ] )
         put_node( n, levl );
   }
//------------------------ поиск образца по дереву ---------------------------------------
private:
   int len_root;                                            // путевая длина      
   int find_root( const string& pattern, int levl = 1 ) {
      if( 1 == levl ) len_root = 0;                         // поиск от корня
      map< const char, int >::iterator it;
      for( it = to[ levl ].begin(); it != to[ levl ].end(); it++ )
         if( it->first == pattern[ 0 ] ) break;
      if( it == to[ levl ].end() )                          // нет 1-го символа
         return -1;
      int n = it->second;                                   // длина найденой дуги 
      if( !to[ n ].empty() )                                // увеличить путевую длину     
         len_root += len[ n ];
      for( int m = 1; m < min( (int)pattern.size(), len[ n ] ); m++ )
         if( pattern[ m ] != s[ pos[ n ] - len[ n ] + m ] ) // не совпадает с патерном
            return -1;
      if( (int)pattern.size() <= len[ n ] )                 // найдена последняя дуга
         return n;
      return find_root( pattern.substr( len[ n ] ), n );    // спускаемся ниже в ветвь
   }
   void add_leave( int node, int shift, vector<int>& vps  ) {
      if( to[ node ].empty() ) {                            // терминальная вершина (лист)
         vps.push_back( pos[ node ] - len[ node ] - shift );
         return;
      }
      for( auto &x: to[ node ] ) {
         int n = x.second;
         if( to[ n ].empty() )                              // терминальная вершина (лист)
            add_leave( n, shift, vps );
         else                                               // внутренний узел
            add_leave( n, shift + len[ n ], vps );
      }
   }
public:
   vector<int> find_pos( const string& pattern ) {
      vector<int> ret = {};
      int r = find_root( pattern );
      if( r > 0 )
         add_leave( r, len_root, ret );                     // пересчитать листья
      return ret;
   }
};

#endif
